Subject: Bug#1172: Modifier Keys not working as expected

From: Stefan Baur <[email-masked]>
Date: Tue, 26 Sep 2017 13:57:55 +0200

Am 26.09.2017 um 12:20 schrieb Ulrich Sibiller:

>> A certain application requires the following keypresses:
> 
> Is the spplication's name secret?

No, but closed-source/commercial/proprietary.

>> - Hold down ctrl, shift and alt
>> - while holding them down, press the space bar
>> - let go of shift and space bar, keep holding down ctrl and alt
> 
> leaving you with ctrl-alt

In theory, yes. But somehow the shift and space bar being pressed and
released first tell it to "keep" the keypresses to itself, rather than
sending them and the function key on to the X Server.

>> - with ctrl and alt pressed, press a function key (F1-F6)
>> - let go of all keys
>>
>> This works when the application is run on :0 - the "ctrl-alt-Fx" is not
>> passed down to X, so no switch to tty1-tty6 occurs, which is the
>> intended and expected behavior.
> 
> So I guess that the application is consuming that very keypress
> somehow by communicating with the X server (grab the key(s) in
> question).
> 
>> However, with the application running in an X2Go session, the same
>> sequence of keys will trigger a switch to tty1-tty6 on the local client.
> 
> The application probably also communicates with the X server which
> this time is nxagent. So nxagent would probably not pass the grab to
> the real X server.
> 
> You could try if the coming autograb feature helps here.

I'll keep that in mind.

> But for analysis we'd need the application to see what is doing.

They offer a time-limited trial version [0], but IIRC, you still need to
register somewhere with your E-Mail address (and they'll send you promo
E-Mails during the trial phase, and possibly even afterwards).

> For the records: I think it is nx-libs so we should open an issue
> there. But I am not sure if we will be able to fix that at all.

As I said, feel free to do so - you're way more knowledgeable about the
code involved than I am.

-Stefan

[0] <https://www.vmware.com/go/tryworkstation-linux-64-de>

-- 
BAUR-ITCS UG (haftungsbeschränkt)
Geschäftsführer: Stefan Baur
Eichenäckerweg 10, 89081 Ulm | Registergericht Ulm, HRB 724364
Fon/Fax 0731 40 34 66-36/-35 | USt-IdNr.: DE268653243